DumpArchiveInputStream
Date: 2017-02-08

org.apache.commons.compress.archivers.dump

## Class DumpArchiveInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.compress.archivers.ArchiveInputStream
    - - org.apache.commons.compress.archivers.dump.DumpArchiveInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class DumpArchiveInputStream
      extends ArchiveInputStream

  The DumpArchiveInputStream reads a UNIX dump archive as an InputStream. Methods are provided to position at each successive entry in the archive, and the read each entry as a normal input stream using read(). There doesn't seem to exist a hint on the encoding of string values in any piece documentation. Given the main purpose of dump/restore is backing up a system it seems very likely the format uses the current default encoding of the system.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected org.apache.commons.compress.archivers.dump.TapeInputStream` | `raw`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DumpArchiveInputStream(java.io.InputStream is)` Constructor using the platform's default encoding for file names.
    `DumpArchiveInputStream(java.io.InputStream is, java.lang.String encoding)` Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the stream for this entry.
    `long` | `getBytesRead()` Returns the current number of bytes read from this stream.
    `int` | `getCount()` Deprecated.
    `DumpArchiveEntry` | `getNextDumpEntry()` Read the next entry.
    `DumpArchiveEntry` | `getNextEntry()` Returns the next Archive Entry in this Stream.
    `DumpArchiveSummary` | `getSummary()` Return the archive summary information.
    `static boolean` | `matches(byte[] buffer, int length)` Look at the first few bytes of the file to decide if it's a dump archive.
    `int` | `read(byte[] buf, int off, int len)` Reads bytes from the current dump archive entry.

    - ### Methods inherited from class org.apache.commons.compress.archivers.ArchiveInputStream

      `canReadEntryData, count, count, pushedBackBytes, read`

    - ### Methods inherited from class java.io.InputStream

      `available, mark, markSupported, read, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### raw

          protected org.apache.commons.compress.archivers.dump.TapeInputStream raw

  - ### Constructor Detail

    - #### DumpArchiveInputStream

          public DumpArchiveInputStream(java.io.InputStream is)
                                 throws ArchiveException

      Constructor using the platform's default encoding for file names.
      Parameters:
        `is` - stream to read from
      Throws:
        `ArchiveException` - on error

    - #### DumpArchiveInputStream

          public DumpArchiveInputStream(java.io.InputStream is,
                                java.lang.String encoding)
                                 throws ArchiveException

      Constructor.
      Parameters:
        `is` - stream to read from
        `encoding` - the encoding to use for file names, use null for the platform's default encoding
      Throws:
        `ArchiveException` - on error
      Since:
        1.6

  - ### Method Detail

    - #### getCount

          @Deprecated
          public int getCount()

      Deprecated.
      Description copied from class: `ArchiveInputStream`
      Returns the current number of bytes read from this stream.
      Overrides:
        `getCount` in class `ArchiveInputStream`
      Returns:
        the number of read bytes

    - #### getBytesRead

          public long getBytesRead()

      Description copied from class: `ArchiveInputStream`
      Returns the current number of bytes read from this stream.
      Overrides:
        `getBytesRead` in class `ArchiveInputStream`
      Returns:
        the number of read bytes

    - #### getSummary

          public DumpArchiveSummary getSummary()

      Return the archive summary information.
      Returns:
        the summary

    - #### getNextDumpEntry

          public DumpArchiveEntry getNextDumpEntry()
                                            throws java.io.IOException

      Read the next entry.
      Returns:
        the next entry
      Throws:
        `java.io.IOException` - on error

    - #### getNextEntry

          public DumpArchiveEntry getNextEntry()
                                        throws java.io.IOException

      Description copied from class: `ArchiveInputStream`
      Returns the next Archive Entry in this Stream.
      Specified by:
        `getNextEntry` in class `ArchiveInputStream`
      Returns:
        the next entry, or `null` if there are no more entries
      Throws:
        `java.io.IOException` - if the next entry could not be read

    - #### read

          public int read(byte[] buf,
                 int off,
                 int len)
                   throws java.io.IOException

      Reads bytes from the current dump archive entry. This method is aware of the boundaries of the current entry in the archive and will deal with them as if they were this stream's start and EOF.
      Overrides:
        `read` in class `java.io.InputStream`
      Parameters:
        `buf` - The buffer into which to place bytes read.
        `off` - The offset at which to place bytes read.
        `len` - The number of bytes to read.
      Returns:
        The number of bytes read, or -1 at EOF.
      Throws:
        `java.io.IOException` - on error

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the stream for this entry.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.InputStream`
      Throws:
        `java.io.IOException`

    - #### matches

          public static boolean matches(byte[] buffer,
                        int length)

      Look at the first few bytes of the file to decide if it's a dump archive. With 32 bytes we can look at the magic value, with a full 1k we can verify the checksum.
      Parameters:
        `buffer` - data to match
        `length` - length of data
      Returns:
        whether the buffer seems to contain dump data